<?php
if(!class_exists('KHNewsHelperFP')){
class KHNewsHelperFP{
		
	function getArticles(&$helper, $params) {		
		global $mainframe;
		
		$catsid = $params->get('catsid');
		$catids = array();
		if(!is_array($catsid)){
			$catids[] = $catsid;
		}
		else{
			$catids = $catsid;
		}

		JArrayHelper::toInteger($catids);
		if($catids){
			if($catids && count($catids)>0){
				foreach ($catids as $k=>$catid){
					if(!$catid) unset($catids[$k]);
				}
			}
		}
		
		$db = & JFactory::getDBO ();
		$user = & JFactory::getUser ();
		$aid = $user->get ( 'aid', 0 );
		
		$contentConfig = &JComponentHelper::getParams ( 'com_content' );
		$noauth = ! $contentConfig->get ( 'shownoauth' );
					
		jimport ( 'joomla.utilities.date' );
		$date = new JDate ( );
		$now = $date->toMySQL ();
		
		$nullDate = $db->getNullDate ();			
		$limit = (int)$helper->get('limit', 10);
		if(!$limit) $limit = 4;
		$limitstart = (int)$helper->get('limitstart', 0);		
		$ordering = $helper->get('ordering', 'ordering');		
		
		// query to determine article count
		$query = 'SELECT a.*,u.name as creator,cc.description as catdesc, cc.title as cattitle,s.description as secdesc, s.title as sectitle,' . 
				' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) ELSE a.id END as slug,' . 
				' CASE WHEN CHAR_LENGTH(cc.alias) THEN CONCAT_WS(":", cc.id, cc.alias) ELSE cc.id END as catslug,' . 
				' CASE WHEN CHAR_LENGTH(s.alias) THEN CONCAT_WS(":", s.id, s.alias) ELSE s.id END as secslug' . 
				' FROM #__content AS a' . ' INNER JOIN #__categories AS cc ON cc.id = a.catid' . 
				' INNER JOIN #__sections AS s ON s.id = a.sectionid' . 
				' INNER JOIN #__content_frontpage AS f ON f.content_id = a.id' .
				' LEFT JOIN #__users AS u ON a.created_by = u.id';
		
		$query .= ' WHERE a.state = 1 ' . ($noauth ? ' AND a.access <= ' . ( int ) $aid . 
						' AND cc.access <= ' . ( int ) $aid . 
						' AND s.access <= ' . ( int ) $aid : '') . 
						' AND (a.publish_up = ' . $db->Quote ( $nullDate ) . 
						' OR a.publish_up <= ' . $db->Quote ( $now ) . ' ) ' . 
						' AND (a.publish_down = ' . $db->Quote ( $nullDate ) . 
						' OR a.publish_down >= ' . $db->Quote ( $now ) . ' )' . 						
						' AND cc.section = s.id' . 
						' AND cc.published = 1' . 
						' AND s.published = 1';		

		if($catids){
			$catids = implode(',', $catids);
			$query .= "\n AND cc.id in ($catids)";
		}		
		
		if($ordering=='rand') $query .= "\n ORDER BY RAND()";
		elseif($ordering=='ordering') $query .= "\n ORDER BY f.".$ordering;
		else $query .= "\n ORDER BY a.".$ordering;
		
		$query .= " LIMIT $limitstart, $limit";
		
		$db->setQuery ( $query);
		$rows = $db->loadObjectList ();
		
		if($helper->get('JPlugins', 1)){
			JPluginHelper::importPlugin ( 'content' );
			$dispatcher = & JDispatcher::getInstance ();
			$com_params = & $mainframe->getParams ( 'com_content' );
		}					
		
		$autoresize 			= 	intval (trim( $helper->get( 'autoresize', 1) ));
		
		$img_align 				=   trim( $helper->get( 'align', 'left' ) );
		$hiddenClasses 			= 	trim( $helper->get( 'hiddenClasses', '' ) );
		
		$bigmaxchar 			= $helper->get ( 'bigmaxchars', 200 );
		$bigimg_w 				= $helper->get ( 'bigimg_w', 150 );
		$bigimg_h 				= $helper->get ( 'bigimg_h', 100 );		
		$bigshowimage 			= $helper->get ( 'bigshowimage', 1 );
		
		$smallmaxchar 			= $helper->get ( 'smallmaxchars', 100 );
		$smallimg_w 			= $helper->get ( 'smallimg_w', 80 );
		$smallimg_h 			= $helper->get ( 'smallimg_h', 80 );				
		$smallshowimage 		= $helper->get ( 'smallshowimage', 1 );
		
		for($i = 0; $i < count ( $rows ); $i ++) {
			$rows [$i]->text = $rows [$i]->introtext;
			if($helper->get('JPlugins', 1)){
				$dispatcher->trigger ( 'onPrepareContent', array (& $rows [$i], & $com_params, 0 ) );
			}
			$rows [$i]->introtext = $rows [$i]->text;
			$rows [$i]->link   		= JRoute::_(ContentHelperRoute::getArticleRoute($rows [$i]->slug, $rows [$i]->catslug, $rows [$i]->sectionid));			
			$rows [$i]->bigimage 	= $helper->replaceImage ($rows [$i], $img_align, $autoresize, $bigmaxchar, $bigshowimage, $bigimg_w, $bigimg_h, $hiddenClasses);			
			$rows [$i]->bigintrotext 	= $rows [$i]->introtext1;
			if($bigmaxchar==0) $rows [$i]->bigintrotext = '';
			$rows [$i]->introtext = $rows [$i]->text;
			$rows [$i]->smallimage 	= $helper->replaceImage ($rows [$i], $img_align, $autoresize, $smallmaxchar, $smallshowimage, $smallimg_w, $smallimg_h, $hiddenClasses);
			$rows [$i]->smallintrotext 	= $rows [$i]->introtext1;
			if($smallmaxchar==0) $rows [$i]->smallintrotext = '';
		}
		
		return $rows;
	}
	
	function getTotal(&$helper, $params){		
		
		$catsid = $params->get('catsid');
		$catids = array();
		if(!is_array($catsid)){
			$catids[] = $catsid;
		}
		else{
			$catids = $catsid;
		}

		JArrayHelper::toInteger($catids);
		if($catids){
			if($catids && count($catids)>0){
				foreach ($catids as $k=>$catid){
					if(!$catid) unset($catids[$k]);
				}
			}
		}
		
		$db = & JFactory::getDBO ();
		$user = & JFactory::getUser ();
		$aid = $user->get ( 'aid', 0 );
		
		$contentConfig = &JComponentHelper::getParams ( 'com_content' );
		$noauth = ! $contentConfig->get ( 'shownoauth' );
					
		jimport ( 'joomla.utilities.date' );
		$date = new JDate ( );
		$now = $date->toMySQL ();
		
		$nullDate = $db->getNullDate ();			
		
		// query to determine article count		
		$query = 'SELECT count(a.id) '. 
				' FROM #__content AS a' . ' INNER JOIN #__categories AS cc ON cc.id = a.catid' . 
				' INNER JOIN #__sections AS s ON s.id = a.sectionid' . 
				' INNER JOIN #__content_frontpage AS f ON f.content_id = a.id';
		
		$query .= ' WHERE a.state = 1 ' . ($noauth ? ' AND a.access <= ' . ( int ) $aid . 
						' AND cc.access <= ' . ( int ) $aid . 
						' AND s.access <= ' . ( int ) $aid : '') . 
						' AND (a.publish_up = ' . $db->Quote ( $nullDate ) . 
						' OR a.publish_up <= ' . $db->Quote ( $now ) . ' ) ' . 
						' AND (a.publish_down = ' . $db->Quote ( $nullDate ) . 
						' OR a.publish_down >= ' . $db->Quote ( $now ) . ' )' . 						
						' AND cc.section = s.id' . 
						' AND cc.published = 1' . 
						' AND s.published = 1';		

		if($catids){
			$catids = implode(',', $catids);
			$query .= "\n AND cc.id in ($catids)";
		}		
				
		$db->setQuery ( $query);
		return $db->loadResult ();
	}
}
}
?>