<?php
/**
 * Plugin Helper File
 *
 * @package     Tabber
 * @version     1.0.2
 * 
 * @author      Peter van Westen <peter@nonumber.nl>
 * @link        http://www.nonumber.nl
 * @copyright   Copyright (C) 2010 NoNumber! All Rights Reserved
 * @license     http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 */

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

/**
** Plugin that places the button
*/
class plgButtonTabberHelper
{
	function plgButtonTabberHelper( &$config )
	{
		// Load plugin parameters
		require_once JPATH_PLUGINS.DS.'system'.DS.'nonumberelements'.DS.'helpers'.DS.'parameters.php';
		$parameters =& NNePparameters::getParameters();
		$system_params = JPluginHelper::getPlugin( 'system', $config['name'] );
		$this->params = $parameters->getParams( $system_params->params, JPATH_PLUGINS.DS.'system'.DS.$config['name'].'.xml' );
	}

	/**
	* Display the button
	*
	* @return array A two element array of ( imageName, textToInsert )
	*/
	function render( $name )
	{
		$mainframe =& JFactory::getApplication();

		$button = new JObject();

		if ( $mainframe->isSite() ) {
			$enable_frontend = $this->params->enable_frontend;
			if ( !$enable_frontend ) {
				return $button;
			}
		}

		$this->params->tag_open =		preg_replace( '#[^a-z0-9-_]#s', '', $this->params->tag_open );
		$this->params->tag_close =		preg_replace( '#[^a-z0-9-_]#s', '', $this->params->tag_close );
		$this->params->tag_delimiter =	( $this->params->tag_delimiter == 'space' ) ? ' ' : '=';

		$text = '{'.$this->params->tag_open.'=Tab Title 1}<br />\nYour text...<br />\n{'.$this->params->tag_open.'=Tab Title 2}<br />\nYour text...<br />\n{/'.$this->params->tag_close.'}';
		$text = str_replace( '\\\\n', '\\n', addslashes( $text ) );

		$document =& JFactory::getDocument();
		$js = "
			function insertTabber(editor) {
				jInsertEditorText('".$text."', editor);
			}
		";
		$document->addScriptDeclaration($js);

		$button_style = 'tabber';
		if ( !$this->params->button_icon ) {
			$button_style = 'blank blank_tabber';
		}
		$document->addStyleSheet( JURI::root( true ).'/plugins/editors-xtd/tabber/css/style.css' );

		$button->set( 'modal', false );
		$button->set( 'link', '#' );
		$button->set( 'onclick', 'insertTabber(\''.$name.'\');return false;');
		$button->set( 'text', JText::_( $this->params->button_text ) );
		$button->set( 'name', $button_style );

		return $button;
	}
}