<?php
/**
 * Main Plugin File
 * Does all the magic!
 *
 * @package     Tabber editor System
 * @version     1.0.2
 *
 * @author      Peter van Westen <peter@nonumber.nl>
 * @link        http://www.nonumber.nl
 * @copyright   Copyright (C) 2010 NoNumber! All Rights Reserved
 * @license     http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 */

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

// Import library dependencies
jimport( 'joomla.event.plugin' );

/**
* System Plugin that places a Tabber code block into the text
*/
class plgSystemTabber extends JPlugin
{
	/**
	* Constructor
	*
	* For php4 compatability we must not use the __constructor as a constructor for
	* plugins because func_get_args ( void ) returns a copy of all passed arguments
	* NOT references. This causes problems with cross-referencing necessary for the
	* observer design pattern.
	*/
	function plgSystemTabber( &$subject, $config )
	{
		// return if disabled via url
		if ( JRequest::getCmd( 'disable_tabber' ) ) { return; }

		// return if current page is a joomfishplus page
		if ( JRequest::getCmd( 'option' ) == 'com_joomfishplus' ) { return; }

		$mainframe =& JFactory::getApplication();

		// return if NoNumber! Elemets plugin is not installed
		jimport( 'joomla.filesystem.file' );
		if ( !JFile::exists( JPATH_PLUGINS.DS.'system'.DS.'nonumberelements.php' ) ) {
			if ( $mainframe->isAdmin() && JRequest::getVar( 'option' ) !== 'com_login' ) {
				// load the admin language file
				$this->loadLanguage( 'plg_'.$config['type'].'_'.$config['name'], JPATH_ADMINISTRATOR );
				$mainframe->enqueueMessage( '', 'error' );
				$msg = JText::_( 'TBR_NONUMBER_ELEMENTS_PLUGIN_NOT_INSTALLED' );
				foreach ( $mainframe->_messageQueue as $m ) {
					if ( $m['message'] == $msg ) {
						$msg = '';
						break;
					}
				}
				$mainframe->enqueueMessage( $msg, 'error' );
			}
			return;
		}


		// return if current page is an administrator page (and not acymailing)
		if ( $mainframe->isAdmin() && JRequest::getCmd( 'option' ) != 'com_acymailing' ) { return; }

		parent::__construct( $subject, $config );

		// Include the Helper
		require_once JPATH_PLUGINS.DS.$config['type'].DS.$config['name'].DS.'helper.php';
		$class = get_class( $this ).'Helper';
		$this->helper = new $class( $config );
	}

	function onAfterDispatch()
	{
		$this->helper->onAfterDispatch();
	}

	function onAfterRender()
	{
		$this->helper->onAfterRender();
	}
}